var FilterEntities = 
{
    AllImageTypes         : {label: 'All images types', filters: 'mds|mdx|b5t|b6t|bwt|ccd|cue|isz|nrg|cdi|iso|ape|flac|vhd|iscsi'}, 
    MediaDescriptorFiles  : {label: 'Media descriptor files (*.mds;*.mdx)', filters: 'mds|mdx'}, 
    BlindWrite            : {label: 'BlindWrite images (*.b5t;*.b6t)', filters: 'b5t|b6t'}, 
    BlindRead             : {label: 'BlindRead images (*.bwt)', filters: 'bwt'}, 
    CloneCD               : {label: 'CloneCD images (*.ccd)', filters: 'ccd'}, 
    CueSheets             : {label: 'Cue sheets files (*.cue)', filters: 'cue'}, 
    CompressedISO         : {label: 'Compressed ISO images (*.isz)', filters: 'isz'}, 
    NeroImages            : {label: 'Nero images (*.nrg)', filters: 'nrg'}, 
    DiscJuggler           : {label: 'DiscJuggler images (*.cdi)', filters: 'cdi'}, 
    StandardISO           : {label: 'Standard ISO images (*.iso)', filters: 'iso'}, 
    APEImages             : {label: 'APE images (*.ape)', filters: 'ape'}, 
    FLACImages            : {label: 'Free Lossless Audio Codec (*.flac)', filters: 'flac'}, 
    VirtualHardDisk       : {label: 'Virtual Hard Disk (*.vhd)', filters: 'vhd'}, 
    ISCSITargets          : {label: 'iSCSI Targets (*.iscsi)', filters: 'iscsi'}
};

/**********************************************************************************************************************/
/**********************************************************************************************************************/
var DTFileSelectControl = function(strControlType)
{
    this.nControlWidth = 500;
    this.nControlHeight = 500;
    this.strContainerObjectName = 'DTFileSelectControl' + strControlType;
    this.strDirViewObjectName = 'DTDirectoryView' + strControlType;
    this.strFileViewObjectName = 'DTFileView' + strControlType;
    this.strResizerObjectName = 'DTResizerControl' + strControlType;
    this.strResizeDraggerObjectName = 'DTResizeDragger' + strControlType;
    this.strFullFileObjectName = 'DTFullFileName' + strControlType;
    this.strExtFilterObjectName = 'DTExtensionsFilter' + strControlType;
    this.strDirViewTableObjectName = 'DTDirectoryViewTable' + strControlType;
    this.strFileViewTableObjectName = 'DTFileViewTable' + strControlType;
    
    this.arrLogicalDrives = new Array();
    this.arrFileList = new Array();
    this.strCurrentFolder = '';
    this.elemSelectedFolder = 0;
    this.elemSelectedFile = 0;
    this.objImageRegExp = new RegExp('\\.(' + FilterEntities.AllImageTypes.filters + ')$', 'i');
    
    this.nDraggerPressedX = 0;
    this.bDraggerCaptured = false;
    this.nMinDraggerX = 150;
    this.nMaxDraggerX = 350;
    this.nResizerWidth = 6;
    this.nResizeDraggerHeight = 25;
    this.nDirExpandCollapseWidth = 9;
    this.bIsVirtual = 'Virtual' == strControlType;
}
/**********************************************************************************************************************/ 
/**********************************************************************************************************************/
DTFileSelectControl.prototype.InitializeCtrl = function(strParentElementID)
{
    var elemDivHolder = document.getElementById(strParentElementID);
    if (!elemDivHolder)
    {
        alert('Failed to find parent element "' + strParentElementID + '" for DTFileSelectControl');
        return;
    }
    
    var elemContainer = document.createElement('div');
    elemContainer.id = this.strContainerObjectName;
    elemDivHolder.appendChild(elemContainer);
    
    this.CreateView(this.strDirViewObjectName, this.strDirViewTableObjectName);
    this.CreateView(this.strFileViewObjectName, this.strFileViewTableObjectName);

    var selfObj = this;
    var elemResizer = document.createElement('div');
    elemResizer.onmousedown = function(event){selfObj.DraggerMouseDownHandler(event);};
    elemResizer.id = this.strResizerObjectName;
    elemDivHolder.appendChild(elemResizer);
    
    var elemResizeDragger = document.createElement('div');
    elemResizeDragger.id = this.strResizeDraggerObjectName;
    elemResizer.appendChild(elemResizeDragger);

    sendAjaxRequest('ajax_get_logical_drives', this.LoadLogicalDevicesNew, this);
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.SetSize = function(nNewWidth, nNewHeight)
{
    var elemMainControl = document.getElementById(this.strContainerObjectName);
    if (!elemMainControl)
        return;

    this.nControlWidth = nNewWidth;
    this.nControlHeight = nNewHeight;
    
    elemMainControl.style.width = this.nControlWidth + 'px';
    elemMainControl.style.height = this.nControlHeight + 'px';

    var elemDirView = document.getElementById(this.strDirViewObjectName);    
    var elemFileView = document.getElementById(this.strFileViewObjectName);
    var elemResizer = document.getElementById(this.strResizerObjectName);
    var elemResizeDragger = document.getElementById(this.strResizeDraggerObjectName);
    
    var nResizerLeft = ((nNewWidth - this.nResizerWidth)  * 0.3);
    
    elemDirView.style.top = '0px';
    elemDirView.style.left = '0px';
    elemDirView.style.width = nResizerLeft +  'px';
    elemDirView.style.height = nNewHeight + 'px';
    
    elemResizer.style.top = '0px';
    elemResizer.style.left = nResizerLeft +  'px';
    elemResizer.style.height = (nNewHeight - 1) + 'px';

    elemResizeDragger.style.top = ((nNewHeight - this.nResizeDraggerHeight) / 2) + 'px';

    elemFileView.style.top = '0px';
    elemFileView.style.left = (nResizerLeft + this.nResizerWidth) + 'px';
    elemFileView.style.width = (nNewWidth - nResizerLeft - this.nResizerWidth) +  'px';
    elemFileView.style.height = nNewHeight + 'px';

    // some resize logic
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.CreateDirectoryElement = function(elemParentTableBody, strPath, strLabel, bExpandable, objThis)
{
    var elemTR = document.createElement('tr');

    var elemTDMargin = document.createElement('td');
    var elemTDContainer = document.createElement('td');
    elemTDMargin.width = objThis.nDirExpandCollapseWidth;
    elemTDContainer.colSpan = 2;
    elemTR.appendChild(elemTDMargin);
    elemTR.appendChild(elemTDContainer);

    var elemTable = document.createElement('table');
    elemTable.className = 'dirCtrlTable';
    elemTable.cellSpacing = '0';
    elemTable.cellPadding = '0';
    elemTDContainer.appendChild(elemTable);
        
    var elemTableBody = document.createElement('tbody');
    elemTable.appendChild(elemTableBody);
    
    var elemTRContainer = document.createElement('tr');
    elemTableBody.appendChild(elemTRContainer);

    var elemTDButton = document.createElement('td');
    elemTDButton.style.padding = '0px 5px 0px 0px';
    var elemDivBtn = document.createElement('div');
    elemDivBtn.className = bExpandable ? 'dirCollapsed' : 'dirEmpty';
    if (bExpandable)
    {
        elemDivBtn.onclick = function(event) {objThis.OnPlusButtonClick(event);};
        elemTRContainer.setAttribute('IsCollapsed', 'true');
    }
    elemTRContainer.setAttribute('pathToElement', strPath);
    elemTDButton.width = objThis.nDirExpandCollapseWidth;
    elemTDButton.appendChild(elemDivBtn);
    elemTRContainer.appendChild(elemTDButton);
    elemTRContainer.elemPlusButton = elemDivBtn;

    var elemTDIcon = document.createElement('td');
    var elemDivIco = document.createElement('div');
    elemDivIco.className = 'closedFolder dirCtrlIcon';
    elemTDIcon.width = objThis.nDirExpandCollapseWidth;
    elemTDIcon.appendChild(elemDivIco);
    elemTRContainer.appendChild(elemTDIcon);
    
    var elemTDLabel = document.createElement('td');
    elemTDLabel.align = 'left';
    elemTDLabel.noWrap = 'true';
    elemTDLabel.innerHTML = strLabel;
    elemTDLabel.className = 'dirFileElement';
    elemTDLabel.onclick = function(event) {objThis.OnDirectoryClick(event);};
    if (bExpandable)
        elemTDLabel.ondblclick = function(event) {objThis.OnDirectoryDblClick(event);};
    elemTRContainer.appendChild(elemTDLabel);
    
    elemParentTableBody.appendChild(elemTR);
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.LoadLogicalDevicesNew = function(strLogicalDevices, objThis)
{
    delete objThis.arrLogicalDrives;
    objThis.arrLogicalDrives = eval( "(" + strLogicalDevices + ")" );

    var elemTableBody = document.createElement('tbody');
    document.getElementById(objThis.strDirViewTableObjectName).appendChild(elemTableBody);
    
    var nLogDrvCount = objThis.arrLogicalDrives.length;
    for (var i = 0; i < nLogDrvCount; i++)
        objThis.CreateDirectoryElement(elemTableBody, objThis.arrLogicalDrives[i].DriveLetter, objThis.arrLogicalDrives[i].DriveLetter[0], true, objThis);
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.CreateView = function(strViewID, strViewTableID)
{
    var elemMainControl = document.getElementById(this.strContainerObjectName);
    var elemViewDiv = document.createElement('div');
    elemViewDiv.id = strViewID;
    elemViewDiv.className = 'dirCtrlDiv';
    
    var elemViewTable = document.createElement('table');
    elemViewTable.id = strViewTableID;
    elemViewTable.cellSpacing = '0';
    elemViewTable.cellPadding = '0';
    elemViewTable.className = 'dirCtrlTable';
    elemViewDiv.appendChild(elemViewTable);
    
    elemMainControl.appendChild(elemViewDiv);
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.OnPlusButtonClick = function(eventObj)
{
    eventObj = eventObj || window.event;
    var objTDSender = eventObj.target || eventObj.srcElement;
    this.OnPlusButtonClickProceed(objTDSender);
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.OnPlusButtonClickProceed = function(objTDSender)
{
    var elemParentTR = objTDSender.parentNode.parentNode;
    if (objTDSender.nodeName != 'DIV')
    {
        alert('WRONG element connected to OnPlusButtonClick handler!');
        return;
    }

    var bIsCollapsed = elemParentTR.getAttribute('IsCollapsed') == 'true';
    if (bIsCollapsed)
        this.ExpandDirectory(objTDSender);
    else
        this.CollapseDirectory(objTDSender);

    elemParentTR.setAttribute('IsCollapsed', bIsCollapsed ? 'false' : 'true');
    objTDSender.className = bIsCollapsed ? 'dirExpanded' : 'dirCollapsed';
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.ExpandDirectory = function(elemToExpand)
{
    var elemParentTR = elemToExpand.parentNode.parentNode;
    var elemDivIco = elemToExpand.parentNode.parentNode.children[1].children[0];
    elemDivIco.className = 'openedFolder dirCtrlIcon';
    
    var elemNext = elemParentTR.nextSibling;
    if (elemNext)
    {
        while (elemNext)
        {
            elemNext.style.display = 'table-row';
            elemNext = elemNext.nextSibling;
        }
    }
    else
    {
        var strParam = 'Folder=' + encodeURIComponent(elemParentTR.getAttribute('pathToElement'));
        sendAjaxRequest('ajax_load_subdirs?' + strParam, this.LoadSubDirectories, this, elemParentTR);
    }
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.CollapseDirectory = function(elemToCollapse)
{
    var elemDivIco = elemToCollapse.parentNode.parentNode.children[1].children[0];
    elemDivIco.className = 'closedFolder dirCtrlIcon';
    
    var elemParentTR = elemToCollapse.parentNode.parentNode;
    var elemNext = elemParentTR.nextSibling;
    while (elemNext)
    {
        elemNext.style.display = 'none';
        elemNext = elemNext.nextSibling;
    }
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.LoadSubDirectories = function(strSubDirs, objThis, elemParent)
{
    var elemParentTBody = elemParent.parentNode; // div->td->tr->tbody

    var arrDirectories = eval( "(" + strSubDirs + ")" );
    for (var i = 0; i < arrDirectories.length; i++)
        objThis.CreateDirectoryElement(elemParentTBody, elemParent.getAttribute('pathToElement') + arrDirectories[i].DirectoryName + '/', arrDirectories[i].DirectoryName, '0' != arrDirectories[i].HasSubDirs, objThis);
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.OnDirectoryClick = function(eventObj)
{
    eventObj = eventObj || window.event;
    var objTDSender = eventObj.target || eventObj.srcElement;
    var elemParentTR = objTDSender.parentNode;
    
    if (this.elemSelectedFolder)
        this.elemSelectedFolder.className = '';
    this.elemSelectedFolder = elemParentTR;
    this.elemSelectedFolder.className = 'selectedFolder';
    
    this.strCurrentFolder = elemParentTR.getAttribute('pathToElement');
    
    var strParam = 'Folder=' + encodeURIComponent(this.strCurrentFolder);
    sendAjaxRequest('ajax_load_files?' + strParam, this.LoadFileList, this, elemParentTR);
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.OnDirectoryDblClick = function(eventObj)
{
    eventObj = eventObj || window.event;
    var objTDSender = eventObj.target || eventObj.srcElement;
    var elemParentTR = objTDSender.parentNode;
    var elemCollExpBtn = elemParentTR.elemPlusButton;

    this.OnPlusButtonClickProceed(elemCollExpBtn);
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.LoadFileList = function(strFiles, objThis, elemParent)
{
    delete objThis.arrFileList;
    objThis.arrFileList = eval( '(' + strFiles + ')' );

    var elemFileTblView = document.getElementById(objThis.strFileViewTableObjectName);
    var elemOldTBody = elemFileTblView.children[0];
    if (elemOldTBody)
        elemFileTblView.removeChild(elemOldTBody);
    
    var elemTableBody = document.createElement('tbody');
    elemFileTblView.appendChild(elemTableBody);

    var nFileCount = objThis.arrFileList.length;
    for (var i = 0; i < nFileCount; i++)
        objThis.CreateFileElement(elemTableBody, objThis.arrFileList[i].FileName, objThis);

    objThis.ApplyExtensionFilter();
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.CreateFileElement = function(elemParentTableBody, strFileName, objThis)
{
    var elemTR = document.createElement('tr');
    elemTR.className = 'fileItem';
    elemTR.onclick = function(event) {objThis.OnFileClick(event);};

    var elemTDIcon = document.createElement('td');
    var elemDivIco = document.createElement('div');
    elemDivIco.className = objThis.objImageRegExp.test(strFileName) ? 'imageIcon' : 'fileIcon';
    elemTDIcon.width = 16;
    elemTDIcon.appendChild(elemDivIco);
    elemTR.appendChild(elemTDIcon);
    
    var elemTDContainer = document.createElement('td');
    elemTDContainer.className = 'dirFileElement';
    elemTDContainer.noWrap = 'true';
    elemTDContainer.innerHTML = strFileName;
    elemTR.appendChild(elemTDContainer);

    elemParentTableBody.appendChild(elemTR);
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.SelectFile = function(strFilename)
{
    document.getElementById(this.strFullFileObjectName).value = this.strCurrentFolder + strFilename;
    (this.bIsVirtual ? WizVirtPageObj : WizVHDPageObj).UpdateFinishButton();
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.OnFileClick = function(eventObj)
{
    eventObj = eventObj || window.event;
    var objTDSender = eventObj.target || eventObj.srcElement;
    
    if (this.elemSelectedFile)
        this.elemSelectedFile.className = 'fileItem';
    this.elemSelectedFile = objTDSender.parentNode;
    this.elemSelectedFile.className = 'selectedFileItem';
    
    this.SelectFile(objTDSender.childNodes[0].nodeValue);
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.OnFileExtensionChanged = function()
{
    this.ApplyExtensionFilter();
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.ApplyExtensionFilter = function()
{
    var strSelectedValue = document.getElementById(this.strExtFilterObjectName).value;
    var bShowAll = '*.*' == strSelectedValue;
    
    var elemFileTblView = document.getElementById(this.strFileViewTableObjectName);
    var elemTBody = elemFileTblView.children[0];
    if (!elemTBody)
        return;

    var RegExpObject = new RegExp(bShowAll ? '' : '\\.(' + strSelectedValue + ')$', 'i');
   
    var elemCurrentTR = elemTBody.children[0];
    while (elemCurrentTR)
    {
        elemCurrentTR.style.display = (bShowAll || RegExpObject.test(elemCurrentTR.children[1].innerHTML)) ? 'table-row' : 'none';
        elemCurrentTR = elemCurrentTR.nextSibling;
    }
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.DraggerMouseDownHandler = function(event)
{
    this.nDraggerPressedX = event.clientX;
    var selfObj = this;
    window.addEventListener ('mouseup', selfObj.DraggerMouseUpHandler, true);
    window.onmousemove = function(event){ selfObj.DraggerMouseMoveHandler(event); };
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.DraggerMouseUpHandler = function()
{
    var selfObj = this;
    window.removeEventListener('mouseup', selfObj.DraggerMouseUpHandler, true);
    window.onmousemove = null;
}
/**********************************************************************************************************************/
DTFileSelectControl.prototype.DraggerMouseMoveHandler = function(event)
{
    var elemResizer = document.getElementById(this.strResizerObjectName);
    var nOldResizerLeft = parseInt(elemResizer.style.left);

    var nDiff = event.clientX - this.nDraggerPressedX;
    var nDX = Math.abs(nDiff);
    var bMoveRight = nDiff > 0;

    if ((bMoveRight && nOldResizerLeft >= this.nMaxDraggerX) || (!bMoveRight && nOldResizerLeft <= this.nMinDraggerX))
        return;

    var nNewResizerLeft = nOldResizerLeft + nDiff;
    if (nNewResizerLeft < this.nMinDraggerX)
        nDX = nOldResizerLeft - this.nMinDraggerX;
    else if (nNewResizerLeft > this.nMaxDraggerX)
        nDX = nNewResizerLeft - this.nMaxDraggerX;
        
    if (nDX <= 0)
        return;

    var nDXSigned = (bMoveRight ? 1 : -1) * nDX;
    var nNewLeft = nOldResizerLeft + nDXSigned;
    elemResizer.style.left = nNewLeft + 'px';
    this.nDraggerPressedX += nDXSigned;

    var elemDirView = document.getElementById(this.strDirViewObjectName);
    elemDirView.style.width = nNewLeft +  'px';

    var elemFileView = document.getElementById(this.strFileViewObjectName);
    elemFileView.style.left = (nNewLeft + this.nResizerWidth) + 'px';
    elemFileView.style.width = (this.nControlWidth - nNewLeft - this.nResizerWidth) + 'px';
}
/**********************************************************************************************************************/







VirtualFileSelCtrlObj = new DTFileSelectControl('Virtual');
VHDFileSelCtrlObj = new DTFileSelectControl('VHD');