var DTWizCommonPage = function()
{
    this.strTargetAliasGenerated = '';
    this.strTargetNameDefaultPrefix = '';
    this.nTargetNameMaxLength = 75;
    this.nTargetAliasMaxLength = 15;
    this.nMaxConnectionsMaxLength = 4;
    this.nTargetLoginMaxLength = 260;
    this.nTargetPasswordMinLength = 12;
    this.nTargetPasswordMaxLength = 16;
    this.strTargetNameValidPrefix = 'iqn.';
    this.nMaxConnectionsGlobal = 1024;

    // crutches for IE7-9
    this.bValidatingMaxConn = false;
    this.bValidatingTargetAlias = false;
    this.bValidatingTargetName = false;
    this.bValidatingTargetLogin = false;
    this.bValidatingTargetPassword = false;
    this.reTargetName = new RegExp('[^A-Z0-9-\.\:]', 'gi');

    this.InitializeMembers();
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.InitializeMembers = function()
{
    this.strValidatedTargetAlias = '';
    this.strValidatedTargetName  = '';
    this.strValidatedMaxConnections = '';
    this.strValidatedTargetLogin = '';
    this.strValidatedTargetPassword = '';
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.InitializePage = function()
{
    var elemMaxConn = document.getElementById('maxConnections');
    var elemTargetName = document.getElementById('targetName');
    var elemTargetAlias = document.getElementById('targetAlias');
    var elemTargetLogin = document.getElementById('TargetLogin');
    var elemTargetPassword = document.getElementById('TargetPassword');

    elemMaxConn.value = '5';
    document.getElementById('CustomTargetName').checked = false;
    elemTargetName.setAttribute('disabled', 'disabled');

    this.InitializeMembers();

    this.strValidatedMaxConnections = '5';
    this.SetTargetAlias('');
    this.SetTargetAliasDef('');
    this.SetTargetLogin('');
    this.SetTargetPassword('');
    this.OnTargetLoginChange();
    this.OnMaxConnectionsChange();

    this.GenerateDefaultAlias();

    if (CompatibilityObj.bIsIE && CompatibilityObj.bOldIE)
    {
        elemMaxConn.attachEvent('onpropertychange', WizCommPageObj.OnMaxConnectionsChange);
        elemTargetAlias.attachEvent('onpropertychange', WizCommPageObj.OnTargetAliasChange);
        elemTargetName.attachEvent('onpropertychange', WizCommPageObj.OnTargetNameChange);
        elemTargetLogin.attachEvent('onpropertychange', WizCommPageObj.OnTargetLoginChange);
        elemTargetPassword.attachEvent('onpropertychange', WizCommPageObj.OnTargetPasswordChange);
    }
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.GenerateDefaultAlias = function()
{
    var nAliasIndex = 0;
    while (true)
    {
        var strNewAlias = 'targetname-' + nAliasIndex;
        this.SetTargetAliasDef(strNewAlias);
        this.CalculateTargetName();

        if (MainPageObj.CheckTargetAliasAvailability(strNewAlias) &&
			MainPageObj.CheckTargetNameAvailability(this.GetTargetName()))
        {
            this.strTargetAliasGenerated = strNewAlias;
            break;
        }

        nAliasIndex++;
    }
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.IsCustomTargetName = function()
{
    return document.getElementById('CustomTargetName').checked;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.SetTargetAliasDef = function(strNewDefAlias)
{
    document.getElementById('targetAlias').placeholder = strNewDefAlias;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.SetTargetAlias = function(strNewAlias)
{
    document.getElementById('targetAlias').value = strNewAlias;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.GetTargetAlias = function()
{
    var elemTargetAlias = document.getElementById('targetAlias');
    var strResult = elemTargetAlias.value;
    if (strResult == '')
        return elemTargetAlias.placeholder;

    return strResult;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.random4 = function () 
{
    return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.GetGUID = function () 
{
    return this.random4() + this.random4();
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.SetTargetName = function(strNewName)
{
    document.getElementById('targetName').value = strNewName;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.GetTargetName = function()
{
    return document.getElementById('targetName').value;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.SetMaxConnections = function(strNewMaxConn)
{
    document.getElementById('maxConnections').value = strNewMaxConn;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.GetMaxConnections = function()
{
    return document.getElementById('maxConnections').value;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.SetTargetLogin = function(strNewTargetLogin)
{
    document.getElementById('TargetLogin').value = strNewTargetLogin;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.GetTargetLogin = function()
{
    return document.getElementById('TargetLogin').value;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.SetTargetPassword = function(strNewTargetPwd)
{
    document.getElementById('TargetPassword').value = strNewTargetPwd;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.GetTargetPassword = function()
{
    return document.getElementById('TargetPassword').value;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.SetTargetNameDefaultPrefix = function(strNewDefPrefix)
{
    this.strTargetNameDefaultPrefix = strNewDefPrefix;
    this.nTargetAliasMaxLength = this.nTargetNameMaxLength - strNewDefPrefix.length;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.SetMaxConnectionsGlobal = function(strNewMaxConnGlob)
{
    this.nMaxConnectionsGlobal = parseInt(strNewMaxConnGlob, 10);
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.CalculateTargetName = function()
{
    if (this.IsCustomTargetName())
        return;

    var strTargetAlias = this.GetTargetAlias();
    var strNewTargetName = ((strTargetAlias == '') ? '' : this.strTargetNameDefaultPrefix + strTargetAlias + '.' + this.GetGUID());
    this.strValidatedTargetName = strNewTargetName;
    document.getElementById('targetName').value = strNewTargetName;
    this.ValidateTargetName();
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.EnableNextButton = function()
{
    var strTargetLogin = this.GetTargetLogin();
    var strTargName = this.GetTargetName();
    var strTargNamePrefix = strTargName.substring(0, 4);
    var bTargNameInvalid = this.reTargetName.test(strTargName);

    var bTargPwdPartValid = true;
    if (!this.bValidatingTargetPassword)
        bTargPwdPartValid = this.ValidateTargetPassword();

    var bEnable = (this.GetTargetAlias() != '') && !bTargNameInvalid && (strTargNamePrefix == this.strTargetNameValidPrefix) && (this.GetMaxConnections() != '') && (strTargetLogin == '' || bTargPwdPartValid);
    WizardObj.EnableWizardNavButtons(WizardNavButtons.Prev | (bEnable ? WizardNavButtons.Next : 0));
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.OnChkSimpleNameClicked = function()
{
    var elemTargetName = document.getElementById('targetName');
    if (this.IsCustomTargetName())
        elemTargetName.removeAttribute('disabled');
    else
        elemTargetName.setAttribute('disabled', 'disabled');

    this.CalculateTargetName();
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.DisplayEmptyError = function()
{
    var strTargName = this.GetTargetName();
    var bTargNameInvalid = this.reTargetName.test(strTargName);
    var strTargNamePrefix = this.GetTargetName().substring(0, 4);
    document.getElementById('ErrorEmptyAliasOrName').style.display = ((strTargNamePrefix == this.strTargetNameValidPrefix) && !bTargNameInvalid && this.GetTargetAlias().length) ? 'none' : 'block';
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.ValidateTargetAlias = function()
{
    var bValidationResult = true;
    var strTargAlias = this.GetTargetAlias();
    var bTargAliasInvalid = this.reTargetName.test(strTargAlias);
    if (bTargAliasInvalid || strTargAlias.length > this.nTargetAliasMaxLength)
    {
        WizCommPageObj.bValidatingTargetAlias = true;
        this.SetTargetAlias(this.strValidatedTargetAlias);
        WizCommPageObj.bValidatingTargetAlias = false;
        return;
    }
    
    this.strValidatedTargetAlias = strTargAlias;
    
    var strClassName = 'txt-input ';
    if (strTargAlias == '')
    {
        strClassName += 'error';
        bValidationResult = false;
    }
    else if (this.strTargetAliasGenerated == strTargAlias)
        strClassName += 'default';

    WizCommPageObj.bValidatingTargetAlias = true;
    document.getElementById('targetAlias').className = strClassName;
    this.DisplayEmptyError();
    WizCommPageObj.bValidatingTargetAlias = false;

    return bValidationResult;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.ValidateTargetName = function()
{
    var bValidationResult = true;
    var strTargName = this.GetTargetName();
    var bTargNameInvalid = this.reTargetName.test(strTargName);
    if (bTargNameInvalid || strTargName.length > this.nTargetNameMaxLength)
    {
        WizCommPageObj.bValidatingTargetName = true;
        this.SetTargetName(this.strValidatedTargetName);
        WizCommPageObj.bValidatingTargetName = false;
        return;
    }
    
    this.strValidatedTargetName = strTargName;
    
    var strClassName = 'txt-input ';
    var strTargNamePrefix = strTargName.substring(0, 4);
    if (strTargNamePrefix != this.strTargetNameValidPrefix)
    {
        strClassName += 'error';
        bValidationResult = false;
    }

    WizCommPageObj.bValidatingTargetName = true;
    document.getElementById('targetName').className = strClassName;
    this.DisplayEmptyError();
    WizCommPageObj.bValidatingTargetName = false;

    return bValidationResult;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.ValidateMaxConnections = function()
{
    // TODO: add complete normalization/validation. String => Int. If not NAN => to String. Check new string length. 
    // If differs from input => update 
    var bValidationResult = true;
    var strMaxConnections = this.GetMaxConnections();
    var nMaxConn = parseInt(strMaxConnections, 10);
    if (strMaxConnections != '' && (isNaN(nMaxConn) || nMaxConn < 1 || nMaxConn > 9999 || strMaxConnections.length > this.nMaxConnectionsMaxLength))
    {
        this.bValidatingMaxConn = true;
        this.SetMaxConnections(this.strValidatedMaxConnections);
        this.bValidatingMaxConn = false;
        return;
    }

    this.strValidatedMaxConnections = strMaxConnections;
    
    var strClassName = 'txt-input ';
    if (strMaxConnections == '' || nMaxConn == 0)
    {
        strClassName += 'error';
        bValidationResult = false;
    }

    this.bValidatingMaxConn = true;
    document.getElementById('maxConnections').className = strClassName;
    document.getElementById('ErrorEmptyMaxConnections').style.display = bValidationResult ? 'none' : 'block';
    document.getElementById('WarningMaxConnections').style.display = ((strMaxConnections == '') || (nMaxConn <= this.nMaxConnectionsGlobal - MainPageObj.nTotalConnections)) ? 'none' : 'block';
    this.bValidatingMaxConn = false;

    return bValidationResult;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.ValidateTargetLogin = function()
{
    var strTargetLogin = this.GetTargetLogin();
    if (strTargetLogin.length > this.nTargetLoginMaxLength)
    {
        this.bValidatingTargetLogin = true;
        this.SetTargetLogin(this.strValidatedTargetLogin);
        this.bValidatingTargetLogin = false;
        return false;
    }

    this.strValidatedTargetLogin = strTargetLogin;

    return true;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.ValidateTargetPassword = function()
{
    var bValidationResult = true;
    var strClassName = 'txt-input ';
    
    if (this.GetTargetLogin().length > 0)
    {
        var strTargetPassword = this.GetTargetPassword();
        var nTargPwdLen = strTargetPassword.length;
        if (nTargPwdLen > this.nTargetPasswordMaxLength)
        {
            this.bValidatingTargetPassword = true;
            this.SetTargetPassword(this.strValidatedTargetPassword);
            this.bValidatingTargetPassword = false;
            return false;
        }

        this.strValidatedTargetPassword = strTargetPassword;

        if (nTargPwdLen < this.nTargetPasswordMinLength)
        {
            strClassName += 'error';
            bValidationResult = false;
        }
    }
    
    this.bValidatingTargetPassword = true;
    document.getElementById('TargetPassword').className = strClassName;
    document.getElementById('ErrorWrongPassword').style.display = bValidationResult ? 'none' : 'block';
    this.bValidatingTargetPassword = false;

    return bValidationResult;
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.OnTargetAliasChange = function()
{
    if (!WizCommPageObj.bValidatingTargetAlias && !WizCommPageObj.bValidatingTargetName)
    {
        WizCommPageObj.ValidateTargetAlias();
        WizCommPageObj.CalculateTargetName();
    }
    WizCommPageObj.EnableNextButton();
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.OnTargetNameChange = function()
{
    if (!WizCommPageObj.bValidatingTargetAlias && !WizCommPageObj.bValidatingTargetName)
        WizCommPageObj.ValidateTargetName();

    WizCommPageObj.EnableNextButton();
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.OnMaxConnectionsChange = function()
{
    if (!WizCommPageObj.bValidatingMaxConn)
        WizCommPageObj.ValidateMaxConnections();

    WizCommPageObj.EnableNextButton();
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.OnTargetLoginChange = function()
{
    if (!WizCommPageObj.bValidatingTargetLogin)
    {
        WizCommPageObj.ValidateTargetLogin();

        WizCommPageObj.bValidatingTargetPassword = true;
        var elemTargetPwd = document.getElementById('TargetPassword');
        if (WizCommPageObj.GetTargetLogin().length > 0)
            elemTargetPwd.removeAttribute('disabled');
        else
            elemTargetPwd.setAttribute('disabled', 'disabled');
        WizCommPageObj.bValidatingTargetPassword = false;

        if (!WizCommPageObj.bValidatingTargetPassword)
            WizCommPageObj.ValidateTargetPassword();
    }

    WizCommPageObj.EnableNextButton();
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.OnTargetPasswordChange = function()
{
    if (!WizCommPageObj.bValidatingTargetPassword)
        WizCommPageObj.ValidateTargetPassword();
    WizCommPageObj.EnableNextButton();
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.HandleAction = function(nAction)
{
    if (nAction == ActionEnum.Next)
    {
        var oldTopHeight = WizardObj.GetFancyBoxTopAndHeight();
        WizardObj.ShowPageByName(WizDevTypePageObj.IsPhysicalDevice() ? WizPagesEnum.ePhysical : (WizDevTypePageObj.IsVirtualDevice() ? WizPagesEnum.eVirtual : WizPagesEnum.eVHD));
        WizardObj.AdjustWizardWindow(oldTopHeight.height, oldTopHeight.top);
        (WizDevTypePageObj.IsPhysicalDevice() ? WizPhysPageObj : (WizDevTypePageObj.IsVirtualDevice() ? WizVirtPageObj : WizVHDPageObj)).UpdateFinishButton();
    }
    else if (nAction == ActionEnum.Prev)
    {
        var oldTopHeight = WizardObj.GetFancyBoxTopAndHeight();
        WizardObj.ShowPageByName(WizPagesEnum.eTargetType);
        WizardObj.AdjustWizardWindow(oldTopHeight.height, oldTopHeight.top);
        WizardObj.EnableWizardNavButtons(WizardNavButtons.Next);
    }
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.GetQueryString = function()
{
    return  '&TargetAlias=' + this.GetTargetAlias() + '&TargetName=' + this.GetTargetName() + '&CustomTargetName=' + this.IsCustomTargetName() + 
            '&TargetLogin=' + encodeURIComponent(this.GetTargetLogin()) + '&TargetPassword=' + encodeURIComponent(this.GetTargetPassword()) + 
            '&MaxConnections=' + this.GetMaxConnections() + '&ImagePassword=' + encodeURIComponent(document.getElementById('ImagePassword').value);
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.FillEditValues = function(objEditValues, strTargetName)
{
    var strAlias = objEditValues[0].TargetAlias;
    var strMaxConn = objEditValues[0].MaxConnections;
    var strLogin = objEditValues[0].Login;
    var strPassword = objEditValues[0].Password;
    var strTargetType = objEditValues[0].TargetType;

    document.getElementById('targetAlias').value = strAlias;
    document.getElementById('targetName').value = strTargetName;
    document.getElementById('maxConnections').value = strMaxConn;
    document.getElementById('TargetLogin').value = strLogin;
    document.getElementById('TargetPassword').value = strPassword;

    this.SetTargetAliasDef(strAlias);
    this.strValidatedTargetAlias = strAlias;
    this.strTargetAliasGenerated = strAlias;
    this.strValidatedTargetName  = strTargetName;
    this.strValidatedMaxConnections = strMaxConn;
    this.strValidatedTargetLogin = strLogin;
    this.strValidatedTargetPassword = strPassword;

    this.SetExclusiveConnection(strTargetType != '1');
    this.OnTargetLoginChange();
    this.OnChkSimpleNameClicked();
}
/**********************************************************************************************************************/
DTWizCommonPage.prototype.SetExclusiveConnection = function(bExclusive)
{
    var elemMaxConn = document.getElementById('maxConnections');
    if (bExclusive)
    {
        this.SetMaxConnections('1');
        this.strValidatedMaxConnections = '1';
        elemMaxConn.setAttribute('disabled', 'disabled');
    }
    else
        elemMaxConn.removeAttribute('disabled');

    this.ValidateMaxConnections();
}
/**********************************************************************************************************************/

WizCommPageObj = new DTWizCommonPage();