var ActionEnum = 
{
    Prev : 'WizPrevButton',
    Next : 'WizNextButton',
    Finish : 'WizFinishButton'
};

var WizardNavButtons = 
{
    Prev : 1,
    Next : 2,
    Finish: 4,
    FinishDisabled : 8
};

var WizPagesEnum = 
{
    eTargetGenProps : {ContainerID: 'WizardPageTargetGeneralProps'},
    eTargetType     : {ContainerID: 'WizardPageTargetType'},
    ePhysical       : {ContainerID: 'WizardPagePhysicalType'},
    eVirtual        : {ContainerID: 'WizardPageVirtualType'},
    eVHD            : {ContainerID: 'WizardPageVHDType'}
};
/**********************************************************************************************************************/
/**********************************************************************************************************************/
var DTAddTargetWizard = function()
{
    this.nCurrentPage = 0;
    this.eCurrentPage = WizPagesEnum.eTargetType;
    this.bWizardInitialized = false;
    this.bNavBtnClickProceeding = false;
    this.nFancyBoxMargin = 15;
    this.nAnimationTime = 500;
    this.bEditMode = false;
    this.strTargetNameToEdit = '';
}
/**********************************************************************************************************************/ 
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.InitializeWizard = function()
{
    sendAjaxRequest('ajax_get_physical_devices', WizPhysPageObj.FillPhysicalDevicesList, WizPhysPageObj);//WizardObj
    sendAjaxRequest('ajax_get_defaults', this.StoreDefaultValues); // also initializes Common Page
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.OpenWizard = function()
{
    if (!MainPageObj.bISCSIAdapterStarted)
    {
        alert('Cannot add target! iSCSI adapter is disabled');
        return;
    }

    this.nCurrentPage = 0;
    this.bEditMode = false;

    WizCommPageObj.InitializePage();
    WizDevTypePageObj.InitializePage();
    WizPhysPageObj.InitializePage();
    WizVirtPageObj.InitializePage();
    WizVHDPageObj.InitializePage();

    this.bNavBtnClickProceeding = false;

    this.ShowPageByName(WizPagesEnum.eTargetType);
    this.ShowWizardButtons(true);
    this.EnableWizardNavButtons(WizardNavButtons.Next);

    CompatibilityObj.WizardOpenHelper(FancyBoxEnum.eWizardDlg);
    $('a[href="#WizardHolder"]').click();
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.OpenEditWizard = function(strTargetName)
{
    this.strTargetNameToEdit = strTargetName;
    sendAjaxRequest('ajax_get_target_props?TargetName=' + strTargetName, this.ProceedOpenEditWizard, this);
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.ShowWizardButtons = function(bIsAddWizard)
{
    document.getElementById('WizPrevButton').style.display = bIsAddWizard ? 'block' : 'none';
    document.getElementById('WizNextButton').style.display = bIsAddWizard ? 'block' : 'none';
    document.getElementById('WizFinishButton').style.display = bIsAddWizard ? 'block' : 'none';
    document.getElementById('WizOKButton').style.display = bIsAddWizard ? 'none' : 'block';
    document.getElementById('WizCancelButton').style.display = bIsAddWizard ? 'none' : 'block';
    document.getElementById('SpanHeaderAddEdit').innerHTML = bIsAddWizard ? 'Add' : 'Edit';
    document.getElementById('SpanHeaderStep1').style.display = bIsAddWizard ? '' : 'none';
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.ProceedOpenEditWizard = function(strTargetPropsJSON, selfObj)
{
    if (strTargetPropsJSON == 'TargetNotFound')
    {
        alert('Target does not exist!');
        MainPageObj.UpdateTargetsList();
        return;
    }

    var arrData = eval( '(' + strTargetPropsJSON + ')' );
    if (arrData.length < 1)
        return;

    WizCommPageObj.FillEditValues(arrData, selfObj.strTargetNameToEdit);
    selfObj.bEditMode = true;
    selfObj.ShowWizardButtons(false);
    selfObj.ShowPageByName(WizPagesEnum.eTargetGenProps);
    CompatibilityObj.WizardOpenHelper(FancyBoxEnum.eWizardDlg);
    $('a[href="#WizardHolder"]').click();
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.ShowPageByName = function(ePageName)
{
    for (var ePage in WizPagesEnum)
        document.getElementById(WizPagesEnum[ePage].ContainerID).style.display = (WizPagesEnum[ePage].ContainerID == ePageName.ContainerID) ? 'block' : 'none';

    this.eCurrentPage = ePageName;
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.StoreDefaultValues = function(strDefaults)
{
    var arrDefaults = eval( '(' + strDefaults + ')' );
    WizCommPageObj.SetTargetNameDefaultPrefix(arrDefaults[0].TargetDefNamePrefix);
    WizCommPageObj.SetMaxConnectionsGlobal(arrDefaults[0].GlobalMaxConnections);
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.GetFancyBoxTopAndHeight = function()
{
    var elemFancyBox = $('.fancybox-wrap');
    var nOldHeight = parseInt(elemFancyBox.css('height'));
    var nOldTop = parseInt(elemFancyBox.css('top'));
    return {top : nOldTop, height : nOldHeight};
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.AdjustWizardWindow = function(nOldHeight, nOldTop)
{
    var nNewHeight = parseInt($('#WizardHolder').css('height')) + this.nFancyBoxMargin * 2;
    var nFancyBoxTop = nOldTop - (nNewHeight - nOldHeight) / 2;

    var selfObj = this;
    $('.fancybox-close').css('display', 'none');
    $('.fancybox-wrap').animate( {top: nFancyBoxTop + 'px', height: nNewHeight + 'px'}, {duration: this.nAnimationTime, complete : function() {  selfObj.bNavBtnClickProceeding = false; $('.fancybox').resize(); $('.fancybox-close').css('display', 'block');  }   });
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.WizardActionDispatcher = function(nAction)
{
    if (this.bNavBtnClickProceeding || this.IsActionDisabled(nAction))
        return;

    this.bNavBtnClickProceeding = true;

    if (this.eCurrentPage == WizPagesEnum.eTargetGenProps)
        WizCommPageObj.HandleAction(nAction);
    else if (this.eCurrentPage == WizPagesEnum.eTargetType)
        WizDevTypePageObj.HandleAction(nAction);
    else if (this.eCurrentPage == WizPagesEnum.ePhysical)
        WizPhysPageObj.HandleAction(nAction);
    else if (this.eCurrentPage == WizPagesEnum.eVirtual)
        WizVirtPageObj.HandleAction(nAction);
    else if (this.eCurrentPage == WizPagesEnum.eVHD)
        WizVHDPageObj.HandleAction(nAction);
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.IsActionDisabled = function(strButtonName)
{
    var elemButton = document.getElementById(strButtonName);
    if (!elemButton)
    {
        alert('Button with ID "' + strButtonName + '" missing!');
        return true;
    }

    return elemButton.getAttribute('enabled') == 'false';
}
/**********************************************************************************************************************/
function DisableButton(strButtonName, strNormalClassName, bEnable)
{
    var elemButton = document.getElementById(strButtonName);
    elemButton.setAttribute('enabled', bEnable);
    elemButton.className = 'button ' + (bEnable ? strNormalClassName : 'disabled');
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.EnableWizardNavButtons = function(nAction)
{
    if (this.bEditMode)
    {
        DisableButton('WizOKButton', 'green', ((nAction & WizardNavButtons.Next) == WizardNavButtons.Next));
        return;
    }

    DisableButton('WizPrevButton', 'default', ((nAction & WizardNavButtons.Prev) == WizardNavButtons.Prev));
    DisableButton('WizNextButton', 'green', ((nAction & WizardNavButtons.Next) == WizardNavButtons.Next));
    DisableButton('WizFinishButton', 'green', !((nAction & WizardNavButtons.FinishDisabled) == WizardNavButtons.FinishDisabled));

    var bDisplayFinishBtn = ((nAction & WizardNavButtons.Finish) == WizardNavButtons.Finish) || ((nAction & WizardNavButtons.FinishDisabled) == WizardNavButtons.FinishDisabled);
    document.getElementById('WizFinishButton').style.display = bDisplayFinishBtn ? 'block' : 'none';
    document.getElementById('WizNextButton').style.display = bDisplayFinishBtn ? 'none' : 'block';
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.EnterImagePasswordCallback = function()
{
    WizardObj.ProceedFinishOperation();
    document.getElementById('ImagePassword').value = '';
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.AddTargetResultHandler = function(strAddResult, selfObj)
{
    if (strAddResult != 'OK')
    {
        if (strAddResult == 'AdapterDisabled')
        {
            MainPageObj.UpdateiSCSIAdapterStatus();
            alert('Cannot add target! iSCSI adapter is disabled');
            return;
        }

        if (strAddResult == 'ResendData') // crutch
        {
            WizardObj.ProceedFinishOperation();
            return;
        }
        else if (strAddResult == 'PasswordRequired')
            ImgPwdDialogObj.OpenQuestion(selfObj.EnterImagePasswordCallback);
        else
            alert(strAddResult);
    }
    else
        MainPageObj.UpdateTargetsList();
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.ProceedFinishOperation = function()
{
    var bIsPhysicalDev = WizDevTypePageObj.IsPhysicalDevice();
    var bIsVHD = !bIsPhysicalDev && !WizDevTypePageObj.IsVirtualDevice();
    var strISVHD = '&IsVHD=' + (bIsVHD ? 'TRUE' : 'FALSE');
    var strParam = 'TargetType=' + (bIsPhysicalDev ? 'Physical' : 'Virtual') + strISVHD + WizCommPageObj.GetQueryString();

    if (!bIsPhysicalDev)
        strParam += '&PathToImage=' + encodeURIComponent(WizDevTypePageObj.IsVirtualDevice() ? WizVirtPageObj.GetPathToImage() : WizVHDPageObj.GetPathToImage());
    else
        strParam += '&PhysDevID=' + encodeURIComponent(WizPhysPageObj.GetSelectedPhysDevID());

    sendAjaxRequest('ajax_add_target?' + strParam, this.AddTargetResultHandler, this);
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.UpdateTargetResultHandler = function(strUpdateResult, selfObj)
{
    if (strUpdateResult != 'OK')
        alert(strUpdateResult);
    else
        MainPageObj.UpdateTargetsList();
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.OnOKBtnClicked = function()
{
    if (this.IsActionDisabled('WizOKButton'))
        return;

    var strParam = 'EditedTargetName=' + this.strTargetNameToEdit + WizCommPageObj.GetQueryString();
    sendAjaxRequest('ajax_update_target?' + strParam, this.UpdateTargetResultHandler, this);
    $.fancybox.close();
}
/**********************************************************************************************************************/
DTAddTargetWizard.prototype.OnCancelBtnClicked = function()
{
    $.fancybox.close();
}
/**********************************************************************************************************************/


WizardObj = new DTAddTargetWizard();